#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}

constexpr int MAXN = 1e5 + 1;

ll dp[MAXN][2][2];
vector<char> d = {'1', '2', '3', '5', '7'};

ll solve1(string &s) {
    memset(dp, 0, sizeof dp);
    dp[1][0][0] = 1;
    dp[1][1][0] = (s[0] > '2') + (s[0] > '3') + (s[0] > '5') + (s[0] > '7');
    dp[1][0][1] = s[0] == '1';
    dp[1][1][1] = (s[0] == '2') + (s[0] == '3') + (s[0] == '5') + (s[0] == '7');
    for (int i = 1; i < s.size(); ++i) {
        for (char j: d) {
            if (j < s[i]) {
                if (j == '1') {
                    dp[i + 1][0][0] += dp[i][0][0];
                    dp[i + 1][0][0] += dp[i][1][0];
                    dp[i + 1][0][1] += dp[i][0][1];
                    dp[i + 1][0][1] += dp[i][1][1];
                } else {
                    dp[i + 1][0][1] += dp[i][0][0];
                    dp[i + 1][0][1] += dp[i][1][0];
                }
            } else if (j == s[i]) {
                if (j == '1') {
                    dp[i + 1][0][0] += dp[i][0][0];
                    dp[i + 1][1][0] += dp[i][1][0];
                    dp[i + 1][0][1] += dp[i][0][1];
                    dp[i + 1][1][1] += dp[i][1][1];
                } else {
                    dp[i + 1][0][1] += dp[i][0][0];
                    dp[i + 1][1][1] += dp[i][1][0];
                }
            } else {
                if (j == '1') {
                    dp[i + 1][0][0] += dp[i][0][0];
                    dp[i + 1][0][1] += dp[i][0][1];
                } else {
                    dp[i + 1][0][1] += dp[i][0][0];
                }
            }
        }
    }
    ll ans = 0;
    for (int i = 1; i <= s.size(); ++i) {
        ans += dp[i][0][1] + dp[i][1][1];
    }
    return ans;
}

void solve() {
    string l, r;
    cin >> l >> r;
    bool b = true, bilo = false;
    for (int i = 0; i < l.size(); ++i) {
        if (l[i] == '0') {
            b = false;
            break;
        }
        if (l[i] == '2' || l[i] == '3' || l[i] == '5' || l[i] == '7') {
            if (bilo) {
                b = false;
                break;
            }
            bilo = true;
        }
    }
    cout << solve1(r) - solve1(l) + (b && bilo) << endl;
}
