#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}

constexpr int MAXN = 201, MOD = 1e9 + 7;

ll dp[MAXN][4];

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        vector<int> a(n);
        bool b = true;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            if (a[i] > 1) {
                b = false;
                break;
            }
        }
        if (!b) {
            cout << 0;
            return;
        }
        cout << 1 << '\n';
        return;
    }
    // if (k == 3) {
    //     cout << 24 << '\n';
    //     return;
    // }
    vector<int> a(n);
    bool b = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] > 3) {
            b = false;
        }
    }
    if (!b) {
        cout << 0 << '\n';
        return;
    }
    if (a[0] == 0) {
        dp[0][0] = 1;
    } else if (a[0] == 1) {
        dp[0][1] = 1;
        dp[0][2] = 1;
    } else if (a[0] == 2) {
        dp[0][3] = 1;
    } else {
        cout << 0;
        return;
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] == 0) {
            dp[i][0] += dp[i - 1][0] + dp[i - 1][2];
        } else if (a[i] == 1) {
            dp[i][0] += dp[i - 1][1] + dp[i - 1][3];
            dp[i][1] += dp[i - 1][0] + dp[i - 1][2];
            dp[i][2] += dp[i - 1][0] + dp[i - 1][2];
        } else if (a[i] == 2) {
            dp[i][1] += dp[i - 1][1] + dp[i - 1][3];
            dp[i][2] += dp[i - 1][1] + dp[i - 1][3];
            dp[i][3] += dp[i - 1][0] + dp[i - 1][2];
        } else {
            dp[i][3] += dp[i - 1][1] + dp[i - 1][3];
        }
        dp[i][0] %= MOD;
        dp[i][1] %= MOD;
        dp[i][2] %= MOD;
        dp[i][3] %= MOD;
    }
    if (a.back() == 0) {
        cout << dp[n - 1][0] << '\n';
    } else if (a.back() == 1) {
        cout << dp[n - 1][1] + dp[n - 1][2] << '\n';
    } else {
        cout << dp[n - 1][3] << '\n';
    }
}
