#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("Unroll-loops")
using namespace std;


using ll = long long;


void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
}


void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    if (n <= 5 && m <= 5 && k <= 5) {
        vector<vector<int> > a(n, vector<int>(m));
        for (int i = 0; i < k; i++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            a[x][y] = 1;
        }
        ll answer = 0;
        vector<int> p(n - 1 + m - 1);
        for (int i = 0; i < n - 1; ++i) {
            p[i] = 1;
        }
        for (int i = n - 1; i < n - 1 + m - 1; ++i) {
            p[i] = 2;
        }
        do {
            vector<int> naz(n - 1 + m - 1);
            for (int i = 0; i < n - 1; ++i) {
                naz[i] = 1;
            }
            for (int i = n - 1; i < n - 1 + m - 1; ++i) {
                naz[i] = 2;
            }
            do {
                vector<vector<bool> > used(n, vector<bool>(m));
                int sum = 0;
                int x = 0, y = 0;
                for (int i = 0; i < n - 1 + m - 1; ++i) {
                    if (p[i] == 1) {
                        x++;
                    } else {
                        y++;
                    }
                    used[x][y] = 1;
                    sum += a[x][y];
                }
                bool ans = true;
                for (int i = 0; i < n - 1 + m - 1; ++i) {
                    if (naz[i] == 1) {
                        x--;
                    } else {
                        y--;
                    }
                    if (used[x][y]) {
                        ans = false;
                        break;
                    }
                    used[x][y] = 1;
                    sum += a[x][y];
                }
                if (ans && sum == k) {
                    answer++;
                }
            } while (next_permutation(naz.begin(), naz.end()));
        } while (next_permutation(p.begin(), p.end()));
        cout << answer % int(1e9 + 7) << '\n';
        return;
    }
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        a[x][y] = 1;
    }
    ll ans = 0;
    for (int v = 0; v < n - 1; ++v) {
        for (int z = v + 1; z < m; ++z) {
            ll sum = a[0][0] + a[n - 1][m - 1];
            for (int i = 0; i <= v; ++i) {
                sum += a[1][i];
            }
            for (int i = v; i < m - 1; ++i) {
                sum += a[2][i];
            }
            for (int i = z; i < m; ++i) {
                sum += a[1][i];
            }
            for (int i = 1; i <= z; ++i) {
                sum += a[0][i];
            }
            if (sum == k) {
                ans++;
            }
        }
    }
    cout << ans % int(1e9 + 7) << '\n';
}
