#include <bits/stdc++.h>


using namespace std;


using ll = long long;


void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
}

const int LEN = 100001;

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > c(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        c[i].resize(k);;
        for (int j = 0; j < k; j++) {
            cin >> c[i][j];
        }
    }
    bitset<LEN> f(1);
    vector<vector<pair<int, int> > > pred(n);
    pred[0].resize(s + 1, {-1, 0});
    for (int i = 0; i < c[0].size(); i++) {
        for (int j = f._Find_first(); j < s + 1; j = f._Find_next(j)) {
            if (j + c[0][i] < s + 1 && pred[0][j + c[0][i]].first == -1) {
                pred[0][j + c[0][i]] = {i, 0};
            }
        }
        f |= (f << c[0][i]);
    }
    f[0] = 0;
    vector<vector<int> > ans(n);
    for (int i = 1; i < n; i++) {
        pred[i].resize(s + 1, {-1, 0});
        bitset<LEN> b;
        for (int j = 0; j < c[i].size(); j++) {
            for (int k = f._Find_first(); k < s + 1; k = f._Find_next(k)) {
                if (k + c[i][j] < s + 1 && pred[i][k + c[i][j]].first == -1) {
                    pred[i][k + c[i][j]] = {j, !b[k]};
                }
            }
            b |= (f << c[i][j]);
            f |= (f << c[i][j]);
        }
        f = b;
    }
    if (!f[s]) {
        cout << "No\n";
        return;
    }
    int indx = n - 1;
    while (s) {
        if (indx < 0 || pred[indx][s].first == -1) {
            cout << "No\n";
            return;
        }
        ans[indx].emplace_back(pred[indx][s].first);
        ll spr = s;
        s -= c[indx][pred[indx][s].first];
        if (pred[indx][spr].second == 1) {
            indx--;
        }
    }
    for (int j = 0; j < n; ++j) {
        if (ans[j].empty()) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    for (int j = 0; j < n; ++j) {
        cout << ans[j].size() << '\n';
        for (int k = 0; k < ans[j].size(); k++) {
            cout << ans[j][k] + 1 << ' ';
        }
        cout << '\n';
    }
}
